# Generates colors which are equally spaced in the RGB cube.
# Useful for coloring classes.
BEGIN{
  levels = 256
  side = 2
  inc = levels / side
  axes = 3
  colors(0, vec)
}

function colors(axis, vec,  i)
{
  if(axis == axes) {
    for(i=0;i<axes;i++) printf "%d ",vec[i]
    printf "\n"
    return
  }
  vec[axis] = inc/2
  for(i = 0; i < side; i++) {
    colors(axis+1, vec)
    vec[axis] += inc
  }
}
