#include <boa/boa.h>

main()
{
  Obj t, ord, iter, seek;
  Boa_Startup();
  
  ord = Boa_Create(T_Ord);
  Boa_PrintNL(stdout, ord);

  Boa_StringSet(ord, "i", BOA_INSERT, Boa_Int_Create(7));
  Boa_StringSet(ord, "s", BOA_INSERT, Boa_String_Create(strdup("hello")));
  Boa_PrintNL(stdout, ord);

  /* now try to iterate over it */
  if(Boa_StringGet(ord, "_iter", 0, NULL, &iter) != TPM_OK) {
    fprintf(stderr, "get _iter failed\n");
    exit(1);
  }
  Boa_PrintNL(stdout, iter);

  /* relative addressing */
  if(Boa_IntGet(iter, 0, 0, NULL, &t) != TPM_OK) {
    fprintf(stderr, "iter(0) failed\n");
    exit(1);
  }
  Boa_PrintNL(stdout, t);
  Boa_Release(t);
  if(Boa_IntGet(iter, 1, 0, NULL, &t) != TPM_OK) {
    fprintf(stderr, "iter(1) failed\n");
    exit(1);
  }
  Boa_PrintNL(stdout, t);
  Boa_Release(t);
  if(Boa_IntGet(iter, 1, 0, NULL, &t) != TPM_OK) {
    fprintf(stderr, "iter(1) failed\n");
    exit(1);
  }
  Boa_PrintNL(stdout, t);
  Boa_Release(t);
  if(Boa_IntGet(iter, 1, 0, NULL, &t) == TPM_OK) {
    fprintf(stderr, "iter(1) didn't fail\n");
    exit(1);
  }

#if 0
  /* seeking */
  if(Boa_StringGet(iter, "seek", 0, NULL, &seek) != TPM_OK) {
    fprintf(stderr, "get seek failed\n");
    exit(1);
  }
  Boa_PrintNL(stdout, seek);
  if(Boa_IntGet(seek, 1, 0, NULL, &t) != TPM_OK) {
    fprintf(stderr, "seek(1) failed\n");
    exit(1);
  }
  Boa_PrintNL(stdout, t);
  Boa_Release(t);
  if(Boa_StringGet(seek, "i", 0, NULL, &t) != TPM_OK) {
    fprintf(stderr, "seek(i) failed\n");
    exit(1);
  }
  Boa_PrintNL(stdout, t);
  Boa_Release(t);
#endif
  /* now start relative again */
  if(Boa_IntGet(iter, 1, 0, NULL, NULL) != TPM_OK) {
    fprintf(stderr, "iter skip failed\n");
    exit(1);
  }
  if(Boa_IntGet(iter, 1, 0, NULL, &t) != TPM_OK) {
    fprintf(stderr, "iter(1) failed\n");
    exit(1);
  }
  Boa_PrintNL(stdout, t);
  Boa_Release(t);

  Boa_Shutdown();
  exit(0);
}
