#include <boa/boa.h>

/* Globals *******************************************************************/
Type T_Int;

/* Functions *****************************************************************/

Obj Boa_Int_Create(int i)
{
  Obj t = Boa_Create(T_Int);
  Boa_Int_Value(t) = i;
  return t;
}

static int SPrint(Obj self, StrStream ss)
{
  return StrStreamPutInt(ss, *(int*)self->value);
}

static struct Boa_Methods methods = {
  Empty_Init, Empty_Final, Empty_Clean,
  SPrint, Generic_Copy, Generic_Compare, Generic_Hash,
  Err_StringGet, Err_StringSet,
  Err_IntGet, Err_IntSet,
  Generic_ObjGet, Generic_ObjSet
};

Obj Boa_Int_Define(void)
{
  T_Int = Boa_SimpleType_Create("int", &methods, sizeof(int), sizeof(int));
  return T_Int;
}
