#include "isa.h"

void Print(IntStackArray a)
{
  int i;
  for(i=0;i<a->len;i++) {
    printf("%d (%d) ", IntStackArrayElt(a,i), 
	   a->stack[i] ? ListSize(a->stack[i]) : 0);
  }
  printf("\n");
}

main()
{
  IntStackArray a;
  int i;

  a = IntStackArrayCreate(5);
  for(i=0;i<5;i++) {
    IntStackArrayElt(a,i) = i;
  }
  Print(a);
  IntStackArrayPush(a,3);
  IntStackArrayElt(a,3) = 10;
  Print(a);
  IntStackArrayPush(a,3);
  IntStackArrayElt(a,3) = 11;
  IntStackArrayPush(a,0);
  IntStackArrayElt(a,0) = 9;
  Print(a);
  IntStackArrayPop(a,3);
  IntStackArrayPop(a,0);
  Print(a);
  IntStackArrayPop(a,3);
  Print(a);
  IntStackArrayFree(a);
  MEM_BLOCKS();
  MEM_STATUS();
}

