#include <stdio.h>
#include "dlist.h"

void DListPrint(DList list)
{
  int *ip;
  if(DListSize(list) == 0) printf("<empty>");
  else {
    DListIter(p, ip, list) {
      printf("%d ", *ip);
    }
  }
  printf("\n");
}

main()
{
  DList list;

  list = DListCreate(GenericFree);
  DListPrint(list);
  DListAddFront(list, IntCreate(4));
  DListPrint(list);
  DListAddRear(list, IntCreate(5));
  DListPrint(list);
  DListAddFront(list, IntCreate(3));
  DListPrint(list);
  DListRemove(list, DListRear(list), NULL);
  DListPrint(list);
  DListRemove(list, DListFront(list), NULL);
  DListPrint(list);
  DListRemove(list, DListRear(list), NULL);
  DListPrint(list);
  DListRemove(list, DListRear(list), NULL);
  DListPrint(list);

  DListFree(list);
  MEM_BLOCKS();
  MEM_STATUS();
}
