# ls -1 view/image | tclsh7.5 $PHOTOBOOK_ROOT/src/misc/copy.tcl ohta_hist.old ohta_hist
if {$argc < 2} {puts stderr "usage: inputdir outputdir < files"; exit}
load_ph
set od [boa create [boa type objDir]]

unpack $argv in out
set in [boa get $od $in]
set out [boa get $od $out]
boa free $od

while {[gets stdin member] > 0} {
    puts stderr $member
    set t [boa get $in $member]
    boa set $out $member $t
}
exit
