#include <stdio.h>

int main(int argc, char *argv[])
{
  int start, end;
  if(argc < 3) {
    fprintf(stderr, "usage: %s start end\n", argv[0]);
    exit(1);
  }
  start = atoi(argv[1]);
  end = atoi(argv[2]);
  fseek(stdin, start, SEEK_CUR);
  while(end >= start) {
    int c = getchar();
    if(c == EOF) break;
    putchar(c);
    end--;
  }
  exit(0);
}
