#include <stdio.h>
#include <tpm/partition.h>

void main(int argc, char *argv[])
{
  Partition p;
  FILE *fp;
  int num_elts;

  if(argc < 3) {
    printf("%s <num_elts> <partition>\n", argv[0]);
    printf("To normalize a partition\n");
    exit(0);
  }

  num_elts = atoi(argv[1]);

  fp = fopen(argv[2], "r");
  if(!fp) {
    printf("Cannot open `%s'\n", argv[2]);
    exit(1);
  }
  p = ReadPartition(fp, num_elts);
  fclose(fp);

  NormalizePartition(p);
  WritePartition(stdout, p);
}
