/* Square the edge costs in a SpanTree */
#include "spantree.h"

main()
{
  int i;
  SpanTree st = SpanTreeCreateFromFile("-");
  if(!st) {
    TpmLoadErrno();
    TpmPrintError(stderr);
    exit(1);
  }
  for(i=0;i<st->num_nodes;i++) {
    st->node[i].edge *= st->node[i].edge;
  }
  SpanTreeWrite(st, stdout);
  SpanTreeFree(st);
  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}
