#load-formats

set canvas .cf.c

frame .cf

# scrollbars
scrollbar .cf.s1 -command "$canvas yview" -relief sunk
scrollbar .cf.s2 -orient horiz -command "$canvas xview" -relief sunk
pack .cf.s2 -side bottom -fill x
pack .cf.s1 -side right -fill y
#$canvas config -xscroll ".cf.s2 set" -yscroll ".cf.s1 set"

# canvas
canvas $canvas -scrollregion {-3c -2c 100c 10000c} \
	-yscrollcommand ".cf.s1 set" \
	-xscrollcommand ".cf.s2 set"
pack .cf.c -expand 1 -fill both
pack .cf -expand 1 -fill both

bind $canvas <2> "$canvas scan mark %x %y"
bind $canvas <B2-Motion> "$canvas scan dragto %x %y"

label .info -text "Right button drags the canvas"
pack .info -expand 1 -fill x

button .quit -text Dismiss -command {exit}
pack .quit -expand 1 -fill x

source /usr/tmp/tktree.data
