/* Arithmetic functions. */

int Boa_Add(Obj self, int nargs, int nrets, Obj *args)
{
  int sum = 0;
  char error = 0;
  if(nrets != 1) error = 1;
  for(i=0;i<nargs;i++) {
    if(args[i]->type != T_Int) error = 1;
    else sum += Boa_Int_Value(args[i]);
    Boa_Release(args[i]);
  }
  if(error) return TPM_ERROR;
  args[0] = Boa_Int_Create(sum);
  return TPM_OK;
}
