#include <boa/boa.h>
#include <boa/image.h>

int ImageReverse(Obj context)
{
  int i;
  Obj t;
  TpmImage image, reverse;
  TRY(Boa_StringGet(context, "image", 0, &T_Image, &t));
  image = Image_Value(t);
  reverse = TpmImageCreate(image->width, image->height, image->channels);
  for(i=0;i<image->len;i++) reverse->d[i] = 255 - image->d[i];
  return Boa_StringSet(context, "reverse", 0, Boa_Ptr_Create(reverse));
}
