#include <boa/boa.h>

main()
{
  Obj t, dict;
  Boa_Startup();
  
  dict = Boa_Create(T_Dict);
  Boa_PrintNL(stdout, dict);

  t = Boa_Int_Create(7);
  if(Boa_StringSet(dict, "i", BOA_INSERT, t) != TPM_OK) {
    fprintf(stderr, "set(i) failed\n");
    exit(1);
  }
  t = Boa_String_Create(strdup("hello"));
  if(Boa_StringSet(dict, "s", BOA_INSERT, t) != TPM_OK) {
    fprintf(stderr, "set(s) failed\n");
    exit(1);
  }
  Boa_PrintNL(stdout, dict);

  if(Boa_StringGet(dict, "i", 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(i) failed\n");
    exit(1);
  }
  printf("i : "); Boa_PrintNL(stdout, t);

  if(Boa_StringGet(dict, "s", 0, &T_String, &t) != TPM_OK) {
    fprintf(stderr, "get(s) failed\n");
    exit(1);
  }
  printf("s : "); Boa_PrintNL(stdout, t);

  Boa_Shutdown();
  exit(0);
}
