#include <boa/boa.h>

main()
{
  Obj i1, v1, i2, v2, i3, v3, dict, t;
  Boa_Startup();
  
  dict = Boa_Create(T_IdDict);
  Boa_Print(stdout, dict); putchar('\n');

  i1 = Boa_String_Create("one");
  v1 = Boa_Int_Create(1);
  i2 = Boa_Int_Create(2);
  v2 = Boa_String_Create("two");
  i3 = Boa_Int_Create(2);
  v3 = Boa_String_Create("two#2");

  if(Boa_ObjSet(dict, i1, BOA_INSERT, v1) != TPM_OK) {
    fprintf(stderr, "set(one) failed\n");
    exit(1);
  }
  if(Boa_ObjSet(dict, i2, BOA_INSERT, v2) != TPM_OK) {
    fprintf(stderr, "set(2) failed\n");
    exit(1);
  }
  if(Boa_ObjSet(dict, i3, BOA_INSERT, v3) != TPM_OK) {
    fprintf(stderr, "set(2) failed\n");
    exit(1);
  }
  Boa_Print(stdout, dict); putchar('\n');

  if(Boa_ObjGet(dict, i1, 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(one) failed\n");
    exit(1);
  }
  printf("one : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  if(Boa_ObjGet(dict, i2, 0, &T_String, &t) != TPM_OK) {
    fprintf(stderr, "get(2) failed\n");
    exit(1);
  }
  printf("2 : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  if(Boa_ObjGet(dict, i3, 0, &T_String, &t) != TPM_OK) {
    fprintf(stderr, "get(2) failed\n");
    exit(1);
  }
  printf("2 : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  Boa_Shutdown();
  exit(0);
}
