#include <boa/boa.h>
#include <boa/image.h>

main(int argc, char *argv[])
{
  char *fname = "-";
  Obj t, formatter, file, od;
  Boa_Startup();
  Boa_Image_Pkg();
  od = Boa_Create(T_ObjDir);

  if(argc > 1) fname = argv[1];

#if 0
  formatter = Boa_GetFormatter("tiff");
  assert(formatter);
  file = FileHandle_Open(fname, "r");
  if(!file) {
    ErrorPrint(stderr);
    exit(1);
  }
  if(Boa_ObjGet(formatter, file, 0, NULL, &t) != TPM_OK) {
    ErrorPrint(stderr);
    exit(1);
  }
  Boa_Release(file);
#else
  if(Boa_StringGet(od, fname, 0, NULL, &t) != TPM_OK) {
    ErrorPrint(stderr);
    exit(1);
  }
#endif
  Boa_PrintNL(stderr, t);
  Boa_PrintNL(stderr, t->type);
  
#if 0
  file = FileHandle_Open("-", "w");
  if(Boa_ObjSet(formatter, file, 0, t) != TPM_OK) {
    ErrorPrint(stderr);
    exit(1);
  }
  Boa_Release(formatter);
#else
  if(Boa_StringSet(od, "-", 0, t) != TPM_OK) {
    ErrorPrint(stderr);
    exit(1);
  }
#endif
  Boa_Release(od);

  Boa_Shutdown();
  exit(0);
}
