#include <boa/boa.h>
#include <boa/image.h>

main()
{
  Obj raw, od, t;

  Boa_Startup();
  Boa_Image_Pkg();

  raw = Boa_Create(T_FormatRaw);
  Boa_StringSet(raw, "_width", 0, Boa_Int_Create(128));
  Boa_StringSet(raw, "_height", 0, Boa_Int_Create(128));
  Boa_StringSet(raw, "_channels", 0, Boa_Int_Create(1));
  Boa_StringSet(raw, "_interleaved", 0, Boa_Int_Create(0));
  od = Boa_Create(T_ObjDir);
  if(Boa_StringSet(od, "_formatter", BOA_REPLACE, raw) != TPM_OK) {
    fprintf(stderr, "set(formatter) failed\n");
    exit(1);
  }
  Boa_PrintNL(stdout, od);
  
  if(Boa_StringGet(od, "test_rawdir.in", 0, NULL, &t) != TPM_OK) {
    fprintf(stderr, "get(test_rawdir.in) failed\n");
    exit(1);
  }
  Boa_PrintNL(stdout, t);
  Boa_Release(t);

  Boa_Release(od);
  Boa_Shutdown();
  exit(0);
}
