/* same as test_read but with DefineTcl */
/* for tcl try: list [set a 4] [incr a] $a 
 * for tclEval try: boa parse tcl [boa parse type 0 {(array 3 string)}] {{3 4 5}}
 */
#include <boa/boa.h>
#include <boa/tcl.h>

main()
{
  Obj t, formatter, file;
  Type at;
  Boa_Startup();
  Boa_Tcl_Pkg();
  Boa_Image_Pkg();

#if 1
  at = Boa_Type_Create("(array 3 int)");
#else
  at = NULL;
#endif
  assert(Boa_StringGet(Boa_Formatters, "tclEval", 0, NULL, &formatter) 
	 == TPM_OK);
  assert(Boa_StringSet(formatter, "_path", 0, Boa_String_Create(strdup("./."))) == TPM_OK);
  file = FileHandle_Open("-", "r");
  if(Boa_ObjGet(formatter, file, 0, &at, &t) != TPM_OK) {
    ErrorPrepend("formatter read failed");
    ErrorPrint(stderr);
    exit(1);
  }
  Boa_Release(file);
  Boa_PrintNL(stderr, t);
  Boa_PrintNL(stderr, t->type);
  
  file = FileHandle_Open("-", "w");
  if(Boa_ObjSet(formatter, file, 0, t) != TPM_OK) {
    ErrorPrepend("formatter write failed");
    ErrorPrint(stderr);
    exit(1);
  }
  Boa_Release(formatter);
  putchar('\n');
  if(at) Boa_Release(at);

  Boa_Shutdown();
  exit(0);
}
