#include <boa/boa.h>
#include <boa/vector.h>

main()
{
  Obj t, od;
  Boa_Startup();
  Boa_Vector_Pkg();

  od = Boa_Create(T_ObjDir);
  if(Boa_StringGet(od, "-", 0, NULL, &t) != TPM_OK) {
    fprintf(stderr, "Reader failed\n");
    exit(1);
  }
  if(t->type == T_Vector) {
    VectorPrint(stderr, Boa_Vector_Value(t));
  }
  else if(t->type == T_Matrix) {
    MatrixPrint(stderr, Boa_Matrix_Value(t));
  }
  else if(t->type == T_Volume) {
    VolumePrint(stderr, Boa_Volume_Value(t));
  }
  Boa_StringSet(od, "-", 0, t);

  Boa_Release(od);
  Boa_Shutdown();
  exit(0);
}
