#include <boa/boa.h>
#include <boa/image.h>

/* Globals *******************************************************************/
Type T_Image = NULL;

/* Functions *****************************************************************/

static void Final(Obj self)
{
  if(Boa_Image_Value(self)) TpmImageFree(Boa_Image_Value(self));
}

static int SPrint(Obj self, StrStream ss)
{
  return StrStreamPuts(ss, "anImage");
}

static struct Boa_Methods methods = {
  Empty_Init, Final, Empty_Clean,
  SPrint, Err_Copy, Generic_Compare, Generic_Hash,
  Err_StringGet, Err_StringSet,
  Err_IntGet, Err_IntSet,
  Generic_ObjGet, Generic_ObjSet
};

Obj Boa_Image_Define(void)
{
  T_Image = Boa_SimpleType_Create("image", &methods, 
				  sizeof(TpmImage), sizeof(Ptr));
  return T_Image;
}
