#include <tpm/matrix.h>

void Boa_Vector_Pkg(void);
Obj Boa_Vector_Create(Vector v);
Obj Boa_Matrix_Create(Matrix v);
Obj Boa_Volume_Create(Volume v);
Obj Boa_Matrix_Coerce(Obj t);
Obj Boa_Volume_Coerce(Obj t);

/* vector ********************************************************************/
Boa_DefineFunc Boa_Vector_Define;
extern Type T_Vector;
#define Boa_Vector_Value(t) ((Vector*)(t)->value)[0]

/* matrix ********************************************************************/
Boa_DefineFunc Boa_Matrix_Define;
extern Type T_Matrix;
#define Boa_Matrix_Value(t) ((Matrix*)(t)->value)[0]

/* volume ********************************************************************/
Boa_DefineFunc Boa_Volume_Define;
extern Type T_Volume;
#define Boa_Volume_Value(t) ((Volume*)(t)->value)[0]

/* format_vector *************************************************************/
Boa_DefineFunc Boa_FormatVector_Define;
extern Type T_FormatVector;

/* format_vectorAscii ********************************************************/
Boa_DefineFunc Boa_FormatVectorAscii_Define;
extern Type T_FormatVectorAscii;

/* format_vectorRaw **********************************************************/
Boa_DefineFunc Boa_FormatVectorRaw_Define;
extern Type T_FormatVectorRaw;
