pointcanvas .c -background black -width 400 -height 400
pack .c -fill both -expand 1

label .info -text "Left button places a point   Middle button drags a point   Right button removes a point"
pack .info -fill x -expand 1

proc label_pts {name} {
    $name delete text
    set i 0
    foreach pt [$name find withtag point] {
	unpack [$name coords $pt] x y
	$name create text $x [expr $y - 5] -text $i -fill white -tags text
	incr i
    }
}

button .slink -text "Single-link hierarchy" -command {
    label_pts .c
    set points [pointcanvas_points .c]

    # convert the list into separate lines
    set string ""
    foreach pt $points {
	append string "$pt\n"
    }

    # call matrix_slink
    exec $env(PKG)/cluster/bin/$env(MACHTYPE)/matrix_slink -ascii << $string | $env(PKG)/cluster/../clustering/tktree &
}
pack .slink -fill x

button .quit -text Quit -command exit
pack .quit -fill x
