#include <tpm/hier.h>

void main(int argc, char *argv[])
{
  Hier hier;

  if(argc > 1) {
    fprintf(stderr, "usage: %s < hier > output\n", argv[0]);
    exit(1);
  }

  hier = HierCreateFromFile("-");
  if(!hier) {
    fprintf(stderr, "Bad hier\n");
    exit(1);
  }
  HierReduce(hier);
  HierWrite(hier, stdout);
  HierFree(hier);
  MEM_BLOCKS();
  MEM_STATUS();
}
