#include <tpm/tpm.h>
#include <tpm/vector.h>

typedef double OptScalarFunc(double x, Any data);
typedef double OptMScalarFunc(Vector x, Any data);
/* Modifies y to be the vector result */
typedef void OptVectorFunc(Vector x, Vector y, Any data);

double OptBrent(double a, double b, OptScalarFunc *f, Any data, 
		double *fmin_return);
void OptCG(Vector x, OptMScalarFunc *f, Any fdata, OptVectorFunc *g, Any gdata,
	   double *fmin_return);
void OptPowell(Vector x, OptMScalarFunc *f, Any data, double *fmin_return);
