#include <tpm/tpm.h>
#include "matrixI.h"

main()
{
  MatrixI A;
  FILE *fp;

  A = MatrixICreate(2,3);
  A->d2[0][0] = 1;
  A->d2[0][1] = 2;
  A->d2[0][2] = 3;
  A->d2[1][0] = 4;
  A->d2[1][1] = 5;
  A->d2[1][2] = 6;
  printf("A:\n");
  MatrixIPrint(stdout, A);
  fp = fopen("test_matrixI.data", "w");
  MatrixIPrint(fp, A);
  fclose(fp);
  MatrixIFree(A);

  printf("test_matrixI.data:\n");
  fp = fopen("test_matrixI.data", "r");
  A = MatrixIScan(fp);
  fclose(fp);
  MatrixIPrint(stdout, A);
  MatrixIFree(A);

  MEM_BLOCKS();
  MEM_STATUS();
}
