#ifndef TPM_POLYGON_H_INCLUDED
#define TPM_POLYGON_H_INCLUDED

#ifndef _XLIB_H_
/* taken from Xlib.h */
typedef struct { short x,y; } XPoint;
#endif

typedef struct {
  int npoints;
  XPoint *points;
} Tpm_Polygon;

Tpm_Polygon *Tpm_PolygonCreate(void);
void Tpm_PolygonFree(Tpm_Polygon *poly);
void Tpm_PolygonAddPoint(Tpm_Polygon *poly, XPoint *p);
void Tpm_PolygonsFree(Tpm_Polygon **polys);

#endif
