#ifndef EXP_H_INCLUDED
#define EXP_H_INCLUDED

#include <math.h>

static union {
  double d;
  struct {
#ifdef LITTLE_ENDIAN
    int j,i;
#else
    int i,j;
#endif
  } n;
} _eco;

#define EXP_A (1048576/M_LN2)
#define EXP_C 60601
#define EXP(y) (_eco.n.i = EXP_A*(y) + (1072693248 - EXP_C), _eco.d)

#endif
