#include <tpm/tpm.h>
#include "region.h"

void main(void)
{
  XPoint p;
  Tpm_Polygon poly;
  int i,j;
  Tpm_Region *region;

  poly.npoints = 0;
  /* read poly points from stdin */
  for(;;) {
    if(scanf("%d %d", &p.x, &p.y) < 2) break;
    Tpm_PolygonAddPoint(&poly, &p);
  }

  /* create a region */
  region = Tpm_RegionFromPolygon(&poly);

  /* dump the region as PGM */
  Tpm_RegionWritePGM(stdout, region);

  Tpm_RegionFree(region);
}
