#include <tpm/tpm.h>
#include <tpm/bitset.h>

main()
{
  BitSet set = BitSetCreate(0);
  int i;
  while(1) {
    printf("Enter an integer (-22 to quit): ");
    scanf("%d", &i);
    if(i == -22) break;
    if(BitSetMember(set, i)) {
      printf("%d is in the set\n", i);
      BitSetDelete(set, i);
      printf("Removed %d\n", i);
    }
    else {
      printf("%d is not in the set\n", i);
      BitSetInsert(set, i);
      printf("Inserted %d\n", i);
    }
  }
  BitSetFree(set);
  MEM_STATUS();
  MEM_BLOCKS();
}
