#include "tpm.h"
#include <math.h>

void main(void)
{
  int a[10] = { 4, 2, 8, 9, 3, 1, 0, 7, 5, 6 };
  int *p;

  unsigned long i;
  for(i=0;i<10;i++) {
    printf("Rand: %g\tRandFloat: %g\tRandInt(1,10): %d\tRandNormal: %g\n",
	   Rand(), RandFloat(), RandInt(1,10), RandNormal());
  }
  printf("ipow(2, 5): %g\n", ipow(2, 5));
  printf("ipow(-0.5, -5): %g\n", ipow(-0.5, -5));
  printf("isqrt(0): %ld\n", isqrt(0));
  printf("isqrt(80): %ld\n", isqrt(80));
  printf("isqrt(2147483648): %ld,  sqrt(2147483648): %lg\n", 
	 isqrt(2147483648u), sqrt(2147483648u));
  printf("gcd(12, -18): %d\n", gcd(12, -18));
  printf("NumBits(256): %d\n", NumBits(256));

  printf("array: ");
  for(i=0;i<10;i++) printf("%d ", a[i]);
  printf("\n");

  printf("NumBits: ");
  for(i=0;i<10;i++) printf("%d ", NumBits(a[i]));
  printf("\n");

  p = SortingPermutation(a, 10, sizeof(int), IntCmp, 0);
  printf("sorting permutation: ");
  for(i=0;i<10;i++) printf("%d ", p[i]);
  printf("\n");
  free(p);

  p = SortingPermutation(a, 10, sizeof(int), IntCmp, 1);
  printf("inverse sorting permutation: ");
  for(i=0;i<10;i++) printf("%d ", p[i]);
  printf("\n");
  free(p);

  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}
