#include "trie.h"

void main(void)
{
  Trie trie = NULL, t;
  char str[128];
  char *key, *value;

  for(;;) {
    printf("Enter a single word or key/value pair: ");
    gets(str);
    if(!*str) break;
    key = strtok(str, " ");
    /* reduce the key to 27 values (assumes lowercase input) */
    for(value = key; *value; value++) *value -= 'a'-1;
    value = strtok(NULL, " ");
    if(!value) {
      t = TrieFind(trie, key);
      if(!t) printf("not found\n");
      else printf("%s\n", TrieValue(t));
    }
    else {
      int found;
      t = TrieAdd(&trie, key, &found);
      if(found) printf("found\n");
      else TrieValue(t) = strdup(value);
    }
  }
  TrieFree(trie, GenericFree);
  MEM_BLOCKS();
  MEM_STATUS();
}
