if {$argc < 2} {puts stderr "usage: inputdir outputdir < files"; exit}
load_ph
load-libs f2c blas lapack
set od [boa create [boa type objDir]]

if 0 {
    set func [boa get $od $env(PHOTOBOOK_ROOT)/lib/common/normalize.boa]
} else {
    set func [boa get $od $env(PHOTOBOOK_ROOT)/lib/common/invert.boa]
}

# 1 for color directory, 0 for motion diskArray
if 1 {
    set mapCon [boa create [boa type mapCon]]
    boa set $mapCon _context $func
    set func $mapCon
}

unpack $argv in out
set in [boa get $od $in]
set out [boa get $od $out]
boa free $od

while {[gets stdin member] > 0} {
    puts stderr $member
    set t [boa get $in $member]
    set t2 [boa objGet $func $t]
    boa free $t
    boa set $out $member $t2
}
