#include <boa/boa.h>

int main(int argc, char *argv[])
{
  Obj od, t;
  Boa_Startup();
  Boa_Image_Pkg();
  Boa_Tcl_Pkg();
  Boa_Vector_Pkg();
  /* ~/src/tcl/ph/db/bt10/view/across/ohta_8x8/0 */
#if 0
  Boa_Hier_Pkg();
  Boa_Region_Pkg();
#endif
  /* Boa_StringSet(Boa_Types, "segMap", BOA_INSERT, (Obj)Boa_SegMap_Define()); */

  if(argc < 2) {
    fprintf(stderr, "usage: test_get name > output\n");
    exit(1);
  }

  od = Boa_Create(T_ObjDir);
  if(Boa_StringGet(od, argv[1], '/', NULL, &t) != TPM_OK) {
    ErrorPrint(stderr);
    exit(1);
  }
  Boa_PrintNL(stderr, t);
  if(Boa_StringSet(od, "-", 0, t) != TPM_OK) {
    ErrorPrint(stderr);
    exit(1);
  }
  Boa_Release(od);
  Boa_Shutdown();
  exit(0);
}
