#include <stdio.h>
#include <errno.h>
#ifdef hpux
#include <symlink.h>
#else
#include <unistd.h>
#endif

int main(argc, argv)
int argc;
char *argv[];
{
#define BUFSIZE 1000
  char buf[BUFSIZE];
  int i, len;

  if(argc < 2) { printf("usage: readlink <symlink> ...\n"); exit(1); }
  for(i=1;i<argc;i++) {
    len = readlink(argv[i], buf, BUFSIZE);
    if(len == -1) {
      perror(argv[i]);
    }
    else {
      if(len == BUFSIZE) len--;
      buf[len] = 0;
      printf("%s\n", buf);
    }
  }
  exit(0);
}
