#include <tpm/tpm.h>

int main(int argc, char *argv[])
{
  char *truename;
  if(argc < 2) {
    fprintf(stderr, "usage: truename file\n");
    fprintf(stderr, "to get the canonical name for file (no . or .. or symlinks)\n");
    exit(1);
  }
  truename = Path_TrueName(argv[1]);
  if(!truename) exit(-1);
  printf("%s\n", truename);
  exit(0);
}
